#!/usr/bin/env python

"""
Acorn Electron ULA simulation controller.
"""

from ula import *
import pygame

def update_surface(surface_array, screen_array):
    surface_array[:] = screen_array
    surface_array *= INTENSITY

def mainloop():
    while 1:
        pygame.display.flip()
        event = pygame.event.wait()
        if event.type == pygame.KEYDOWN and event.key == pygame.K_ESCAPE:
            break

if __name__ == "__main__":
    pygame.init()
    screen = pygame.display.set_mode((WIDTH, HEIGHT), 0)
    a = pygame.surfarray.pixels3d(screen)

    ula = get_ula()
    ula_screen = get_screen()

    # Test MODE 2.

    ula.set_mode(2)

    ula.fill(0x3000, 0x5800 - 320, encode((1, 6), 4))
    ula.fill(0x5800 - 320, 0x8000, encode((2, 7), 4))
    update(ula_screen, ula)
    update_surface(a, ula_screen)
    mainloop()

    ula.screen_start = 0x3000 + 2
    update(ula_screen, ula)
    update_surface(a, ula_screen)
    mainloop()

    # Test MODE 6.

    ula.set_mode(6)

    ula.fill(0x6000, 0x6f00 + 160, encode((1, 0, 1, 1, 0, 0, 1, 1), 1))
    ula.fill(0x6f00 + 160, 0x7f40, encode((1, 0, 1, 0, 1, 0, 1, 0), 1))
    update(ula_screen, ula)
    update_surface(a, ula_screen)
    mainloop()

    ula.screen_start = 0x6f00 + 160
    update(ula_screen, ula)
    update_surface(a, ula_screen)
    mainloop()

# vim: tabstop=4 expandtab shiftwidth=4
